var _ = require('underscore');

var Base = require('./base.js');

function Handlebars() {
	Base.call(this);
}

Handlebars.prototype = Object.create(Base.prototype);
Handlebars.prototype.constructor = Base;

Handlebars.prototype.init = function(conf) {
	this.conf = conf;
};

Handlebars.prototype.add = function(key, dest, sources, options) {

	var self = this;

	var files = {};
	files[dest] = sources;

	var hbsoptions = {};

	if (options.partials) {

		// make them all partials
		hbsoptions.partialRegex = /\.hbs$/;

		hbsoptions.processPartialName = function(filePath) {

			/*var parts = filePath.split('/');
			if(parts[0]==='components' && parts[1]==='pure'){
				return 'pure/'+parts[4].replace('.hbs', '');
			}else if(parts[0]==='components' && parts[1]==='ef'){
				return 'ef/'+parts[2].slice(0,-1)+'/'+parts[5].replace('.hbs', '');
			}*/
			var relativePath = filePath.replace(self.conf.sources.components + '/', '');

			var componentName = relativePath.split('/').pop().replace('.hbs', '');
			var namespace = relativePath.split('/').shift();
			var componentString;

			if (self.conf.sources.componentsOptions && self.conf.sources.componentsOptions[namespace] && self.conf.sources.componentsOptions[namespace].atomic) {
				componentString = [
					namespace,
					relativePath.split('/')[1],
					componentName
				].join('/');
			}

			else {
				componentString = namespace + '/' + componentName;
			}

			return componentString;

		};

	}

	this.config[key] = {
		files: files,
		options: hbsoptions
	};

};

module.exports = Handlebars;

