/* jshint node:true */

var _ = require('underscore'),
	fs = require('fs');

function replaceInObject(obj) {

	_.each(obj, function(val, key) {

		if (_.isString(val) && val.substr(0, 16) === '_INCLUDE_STRING:') {
			obj[key] = fs.readFileSync(val.substr(16)).toString();
		}

		if (_.isObject(val)) {
			replaceInObject(val);
		}

	});

}


function tryReadJSON(path) {

	var json;

	try {
		json = JSON.parse(fs.readFileSync(path));
	}

	catch (err) {
		json = {};
	}

	return json;

}



// expose public API

exports.replaceInObject = replaceInObject;
exports.tryReadJSON = tryReadJSON;
