
describe 'pure_grids', ->
	Given -> @subject = @subject.pure_grids
	Then -> typeof @subject == 'object'
	Then -> typeof @subject.init == 'function'

	beforeEach -> @subject.reset()

	describe 'init', ->
		Given -> @subject.init({
			units:[5,12],
			breakpoints:{
				sm: 10,
				md: 20,
				lg: 30,
				foo: 99
			}
		}, 'out/compos')

		Then -> expect(@subject.config).toEqual({
			default_units: {
				dest: 'out/compos/__grids-units.css',
				options: {
					units: [5,12]
				}
			},

			responsive: {
				dest: 'out/compos/__grids-responsive.css',

				options: {
					mediaQueries: {
						sm: 'screen and (min-width: 10em)',
						md: 'screen and (min-width: 20em)',
						lg: 'screen and (min-width: 30em)',
						foo: 'screen and (min-width: 99em)'
					}
				}
			}
		});

	describe 'insertGridPaths', ->

		describe 'no __grid__', ->
			replaced = null
			Given -> replaced = @subject.insertGridPaths(['a', 'b', 'c'])
			Then -> expect(replaced).toEqual(['a', 'b', 'c'])

		describe 'with __grid__', ->
			replaced = null
			Given -> replaced = @subject.insertGridPaths(['a', 'b', '__grid__', 'c'],'p/c')
			Then -> expect(replaced).toEqual(['a', 'b', 'p/c/__grids-units.css','p/c/__grids-responsive.css', 'c'])