process.env.NODE_ENV = 'test';

sife = require('../../lib/loadConfig.js');

describe 'loadConfig', ->
	Given -> @subject = sife

	Then -> typeof @subject == 'function'
	Then -> typeof @subject._private == 'object'
	Then -> typeof @subject._private.fixPaths == 'function'
	Then -> typeof @subject._private.initPathVariables == 'function'
	Then -> typeof @subject._private.replacePathVariables == 'function'


	describe 'replace path variables', ->
		result = null
		Given -> @subject._private.initPathVariables sources:
			components : 'path/to/components'
			base: 'path/to/base',
			themes: 'path/to/themes'
		When ->
			result = {
				foo: '$base/foo',
				bar:[
					'$base/bar',
					'$components/bar'
				],
				baz:{
					baz:'$base/baz',
					bazz:'$themes/baz',
					barbar:{
						bar: '$base/pr'
					}
				},
				build:
					css:
						base:[
							'$components/variables.css',
							'$base/normalize.css',
							'__grid__'
						]
			}
			@subject._private.replacePathVariables(result)

		Then -> result.foo == 'path/to/base/foo'
		Then -> result.bar[0] == 'path/to/base/bar'
		Then -> result.bar[1] == 'path/to/components/bar'
		Then -> result.baz.baz == 'path/to/base/baz'
		Then -> result.baz.bazz == 'path/to/themes/baz'
		Then -> result.baz.barbar.bar == 'path/to/base/pr'
		Then -> result.build.css.base[0] == 'path/to/components/variables.css'
		Then -> result.build.css.base[1] == 'path/to/base/normalize.css'
		Then -> result.build.css.base[2] == '__grid__'



	describe 'fixPaths', ->
		Given -> @result = {foo:'bar/bar',bar:'foo/foo/'}
		Given -> @subject._private.fixPaths(@result, ['foo','bar','coocoo'], './Sife.json')
		Then -> expect(@result).toEqual({foo:'bar/bar',bar:'foo/foo'})